:_mod-docs-content-type: PROCEDURE
// Module included in the following assemblies:
//
// assembly_generating--virtual-machine-debug-logs.adoc

[id="enabling-virtual-machine-debug-logs-during-runtime_{context}"]
= Enabling libvirt debug logs during runtime

You can modify the libvirt daemon's runtime settings to enable debug logs and save them to an output file.

This is useful when restarting the libvirt daemon is not possible because restarting fixes the problem, or because there is another process, such as migration or backup, running at the same time. Modifying runtime settings is also useful if you want to try a command without editing the configuration files or restarting the daemon.

.Prerequisites

* Make sure the `libvirt-admin` package is installed.

.Procedure

. Optional: Back up the active set of log filters.
+
ifeval::[{ProductNumber} == 8]
[subs="+quotes,attributes"]
----
# *virt-admin daemon-log-filters >> virt-filters-backup*
----
endif::[]
ifeval::[{ProductNumber} == 9]
[subs="+quotes,attributes"]
----
# *virt-admin -c virtqemud:///system daemon-log-filters >> virt-filters-backup*
----
endif::[]
+
[NOTE]
====
It is recommended that you back up the active set of filters so that you can restore them after generating the logs. If you do not restore the filters, the messages will continue to be logged which may affect system performance.
====

. Use the `virt-admin` utility to enable debugging and set the filters according to your requirements.
+
.Debugging filter values
[cols="1,9"]
|====
|*1*|logs all messages generated by libvirt.
|*2*|logs all non-debugging information.
|*3*|logs all warning and error messages. This is the default value.
|*4*|logs only error messages.
|====
+
.Sample virt-admin setting for logging filters
====
The following command:

** Logs all error and warning messages from the `remote`, `util.json`, and `rpc` layers
** Logs only error messages from the `event` layer.

ifeval::[{ProductNumber} == 8]
[subs="+quotes,attributes"]
----
# *virt-admin daemon-log-filters "3:remote 4:event 3:util.json 3:rpc"*
----
endif::[]
ifeval::[{ProductNumber} == 9]
[subs="+quotes,attributes"]
----
# *virt-admin -c virtqemud:///system daemon-log-filters "3:remote 4:event 3:util.json 3:rpc"*
----
endif::[]
====

. Use the `virt-admin` utility to save the logs to a specific file or directory.
+
For example, the following command saves the log output to the `libvirt.log` file in the `/var/log/libvirt/` directory.
+
ifeval::[{ProductNumber} == 8]
[subs="+quotes,attributes"]
----
# *virt-admin daemon-log-outputs "1:file:/var/log/libvirt/libvirt.log"*
----
endif::[]
ifeval::[{ProductNumber} == 9]
[subs="+quotes,attributes"]
----
# *virt-admin -c virtqemud:///system daemon-log-outputs "1:file:/var/log/libvirt/libvirt.log"*
----
endif::[]

. Optional: You can also remove the filters to generate a log file that contains all VM-related information. However, it is not recommended since this file may contain a large amount of redundant information produced by libvirt’s modules.
** Use the `virt-admin` utility to specify an empty set of filters.
+
ifeval::[{ProductNumber} == 8]
[subs="+quotes,attributes"]
----
# *virt-admin daemon-log-filters*
  Logging filters:
----
endif::[]
ifeval::[{ProductNumber} == 9]
[subs="+quotes,attributes"]
----
# *virt-admin -c virtqemud:///system daemon-log-filters*
  Logging filters:
----
endif::[]

. Optional: Restore the filters to their original state using the backup file. +
Perform the second step with the saved values to restore the filters.
